Summary: OLPC XO power management
Name: olpc-powerd
Version: 37
Release: 1%{?dist}
License: GPLv2+
Group: System Environment/Base
URL: http://dev.laptop.org/git/users/pgf/powerd/tree/powerd
# Source0: the source tarball is created by "make tarball" from within
# a clone of this git tree: git://dev.laptop.org/users/pgf/powerd
Source0: olpc-powerd-37-gitf617b29.tar.gz
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
BuildRequires: kernel-headers, NetworkManager-glib-devel
Requires: olpc-kbdshim, upstart, ethtool, evtest

# these are all for the manipulation of ohmd -- powerd doesn't need them.
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(post): initscripts
Requires(preun): initscripts

ExclusiveArch: %{ix86} %{arm}

%description
The powerd daemon can function as an easily customizable replacement for ohmd,
which is independent of X, dbus, and hald.  This package provides the powerd
and olpc-switchd daemons, and related utilities.

%package dbus
Summary: D-Bus interface to powerd
Group: System Environment/Base
Requires: olpc-powerd, dbus
BuildRequires: dbus-glib-devel

%description dbus
Provides a dbus-activated daemon to provide access to powerd functionality
over the D-Bus system bus.

%prep
%setup -q

%build
export OPT_FLAGS="$RPM_OPT_FLAGS"
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_sbindir}
mkdir -p $RPM_BUILD_ROOT/%{_bindir}
mkdir -p $RPM_BUILD_ROOT/%{_libexecdir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/dbus-1/system.d
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/init
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/powerd
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/powerd/postresume.d
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/powerd/flags

%{__install} -p -m 755 olpc-switchd $RPM_BUILD_ROOT/%{_sbindir}/olpc-switchd
%{__install} -p -m 755 powerd $RPM_BUILD_ROOT/%{_sbindir}/powerd
%{__install} -p -m 755 pnmto565fb $RPM_BUILD_ROOT/%{_bindir}/pnmto565fb
%{__install} -p -m 755 powerd-config $RPM_BUILD_ROOT/%{_bindir}/powerd-config
%{__install} -p -m 755 olpc-nosleep $RPM_BUILD_ROOT/%{_bindir}/olpc-nosleep
%{__install} -p -m 644 olpc-switchd.upstart $RPM_BUILD_ROOT%{_sysconfdir}/init/olpc-switchd.conf
%{__install} -p -m 644 powerd.upstart $RPM_BUILD_ROOT%{_sysconfdir}/init/powerd.conf
%{__install} -p -m 644 pleaseconfirm.pgm $RPM_BUILD_ROOT%{_sysconfdir}/powerd/pleaseconfirm.pgm
%{__install} -p -m 644 shuttingdown.pgm $RPM_BUILD_ROOT%{_sysconfdir}/powerd/shuttingdown.pgm
%{__install} -p -m 644 powerd.conf.dist $RPM_BUILD_ROOT%{_sysconfdir}/powerd/powerd.conf
%{__install} -p -m 644 version $RPM_BUILD_ROOT%{_sysconfdir}/powerd/version
%{__install} -p -m 644 olpc-pwr-log.sh $RPM_BUILD_ROOT%{_sysconfdir}/powerd/olpc-pwr-log.sh 
%{__install} -p -m 644 usb-inhibits $RPM_BUILD_ROOT%{_sysconfdir}/powerd/flags/usb-inhibits

%{__install} -p -m 755 powerd-dbus/powerd-dbus $RPM_BUILD_ROOT%{_libexecdir}/powerd-dbus
%{__install} -p -m 644 powerd-dbus/powerd.conf $RPM_BUILD_ROOT%{_sysconfdir}/dbus-1/system.d/powerd.conf

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc COPYING

%{_sbindir}/olpc-switchd
%{_sbindir}/powerd
%{_bindir}/pnmto565fb
%{_bindir}/powerd-config
%{_bindir}/olpc-nosleep
%{_sysconfdir}/powerd/olpc-pwr-log.sh
%config(noreplace) %{_sysconfdir}/init/olpc-switchd.conf
%config(noreplace) %{_sysconfdir}/init/powerd.conf
%config(noreplace) %{_sysconfdir}/powerd/pleaseconfirm.pgm
%config(noreplace) %{_sysconfdir}/powerd/shuttingdown.pgm
%config(noreplace) %{_sysconfdir}/powerd/powerd.conf
%config(noreplace) %{_sysconfdir}/powerd/flags/usb-inhibits
%{_sysconfdir}/powerd/version

%files dbus
%defattr(-,root,root,-)
%{_libexecdir}/powerd-dbus
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/powerd.conf

%post
# Only on install
if [ $1 = 1 ] ; then
    if test -e /etc/init.d/ohmd ; then
        service ohmd stop >/dev/null 2>&1
        chkconfig ohmd off 
    fi
    initctl -q start powerd
    initctl -q start olpc-switchd
fi
exit 0

%preun
# Only on uninstall
if [ $1 = 0 ] ; then
    initctl stop -q olpc-switchd
    initctl stop -q powerd
    if test -e /etc/init.d/ohmd
    then
        /sbin/service ohmd start >/dev/null 2>&1
        /sbin/chkconfig ohmd on
    fi
fi
exit 0

%postun
# Restart after upgrade
if [ "$1" -ge "1" ] ; then
    initctl stop -q olpc-switchd
    initctl stop -q powerd
    initctl start -q powerd
    initctl start -q olpc-switchd
fi
exit 0

%changelog
* Wed Oct 19 2011 Daniel Drake <dsd@laptop.org> - 37-1
- Reduce window for suspend during network connection
- Close unused input devices in switchd

* Wed Sep 06 2011 Daniel Drake <dsd@laptop.org> - 36-1
- Use evtest for switch state querying
- powerd-dbus now inhibits suspend while connecting to wireless networks

* Thu Sep 01 2011 Daniel Drake <pgf@laptop.org> - 35-1
- Initial XO-1.75 support

* Sun Feb 20 2011 Daniel Drake <dsd@laptop.org> - 33-1
- latest version

* Thu Feb 10 2011 Daniel Drake <dsd@laptop.org> - 31-3
- -combine gcc option was dropped, switch to -flto

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 31-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Thu Nov 25 2010 Daniel Drake <dsd@laptop.org>
- 31-1
- Lid wakeup improvements on XO-1
- LED bug workaround for XO-1
- Enable wake-on-multicast if salut collaboration is being used

* Mon Nov  8 2010 Daniel Drake <dsd@laptop.org>
- 29-1
- opening lid no longer wakes the laptop, to suppress unwanted
 wakeups when laptops are stacked. (configurable)
- improvements for very short idle timeouts
- add missing dependency on ethtool

* Wed Sep 29 2010 jkeating - 28-2
- Rebuilt for gcc bug 634757

* Wed Sep 22 2010 Daniel Drake <dsd@laptop.org>
- 28-1
- Update to v28, update for Upstart 0.6

* Tue Aug 24 2010 Daniel Drake <dsd@laptop.org>
- 26-1
- Update to v26

* Mon May  3 2010 Paul Fox <pgf@laptop.org>
- 21-1
- close hole where creation of inhibit file won't always inhibit suspend.
- close hole where net traffic won't inhibit suspend after a lot of traffic

* Fri Apr 30 2010 Paul Fox <pgf@laptop.org>
- 20-1
- add preemptive sync on power button, or when idle suspend is imminent.
- fix bug causing power button splash menu to not appear sometimes.
- bring documentation up to date.

* Thu Apr 15 2010 Paul Fox <pgf@laptop.org>
- 19-1
- improve olpc-pwr-log.sh logging
- modify handling of battery dis/charge wakeups which were preventing
  eventual shutdown.

* Tue Apr  6 2010 Paul Fox <pgf@laptop.org>
- 18-1
- ensure dcon is awake and unfrozen if powerd exits.
- enable network activity checks:  pings, inbound traffic for
  established tcp connections, as well as any non-mdns outbound
  traffic, within 5 seconds of the target time, will all keep the
  inhibit suspend.
- bug fixes for recently introduced problems.

* Mon Apr  5 2010 Paul Fox <pgf@laptop.org>
- 17-1
- reorder the background "xxx_is_busy" checks for better useability.

* Tue Mar 30 2010 Paul Fox <pgf@laptop.org>
- 16-1
- inhibit suspend when camera is active
- lower the cpu busy-ness threshold required to inhibit suspend --
  audio apps now inhibit.
- make trace file easier to summarize.  (grep for ": @")
- suppress wake-on-wlan when screen is blanked, by default.

* Wed Mar 24 2010 Paul Fox <pgf@laptop.org>
- 15-1
- ensure battery and AC events are always reported correctly

* Wed Mar 24 2010 Paul Fox <pgf@laptop.org>
- 14-1
- allow keypress to wake from a blanked idle-suspend state
- properly keep wireless working during idle suspends
- check for closed lid on startup, so we sleep right away
- workaround issues with AC jack reporting
- capture stdout to the trace file, to prevent console spew
- force a date stamp into the trace file on startup
- lengthen dim/blank/shutdown timeouts

* Fri Mar 12 2010 Paul Fox <pgf@laptop.org>
- 13-1
- early enhancements/fixes to olpc-pwr-log functionality

* Tue Mar  9 2010 Paul Fox <pgf@laptop.org>
- 12-1
- integrate the functionality of olpc-pwr-log
- setting most timer values to 0 now does something interesting
- catch events that might be lost during brief action wakeups

* Fri Feb 19 2010 Paul Fox <pgf@laptop.org>
- 11-1
- adjust default dim/suspend times (suspend long before dim)
- new olpc-nosleep wrapper command for inhibiting suspend
- support for XO-1.5
- new persistent inhibit file
- unfreeze delay is configurable

* Mon Jan 25 2010 Paul Fox <pgf@laptop.org>
- 10-1
- speedups in splash image drawing
- remove some bash-isms so powerd will run with dash on debian
- improvements to make input switch device detection more robust.
- powerd.wip is work-in-progress for supporting XO-1.5.

* Thu Jul 30 2009 Paul Fox <pgf@laptop.org>
- 9-1
- disable tracing, by default.  use "powerd-control =tracing-on" to enable at runtime.
- create the inhibit file so that root owns it and can make it writeable.
- don't brighten the screen on wlan wakeups.

* Fri Jul 17 2009 Paul Fox <pgf@laptop.org>
- 8-1
- incorporate package review fixups
- commentary and powerd-config UI clarification
- fix fatal bug when battery is missing

* Fri Jul 6 2009 Paul Fox <pgf@laptop.org>
- 7-1
- no longer wake on AC events -- unnecessary
- doc fixups

* Thu Jun 11 2009 Paul Fox <pgf@laptop.org>
- 6-2
- utility targets in makefile

* Sat Jun 6 2009 Paul Fox <pgf@laptop.org>
- 6-1
- various fixes
- incorporate lessons from kbdshim review

* Tue May 5 2009 Paul Fox <pgf@laptop.org>
- 5-1
- fixed ability to shut down with backlight off.  oops.
- various utility bug fixes (powerd-config, olpc-brightness)

* Sun Apr 12 2009 Paul Fox <pgf@laptop.org>
- 4-1
- add control over sleep on lid-close
- resync version numbers

* Sat Apr 11 2009 Paul Fox <pgf@laptop.org>
- 3-3
- fixed powerd-config behavior wrt symlinked configs

* Fri Apr 10 2009 Paul Fox <pgf@laptop.org>
- 3-2
- fix bugs, implement cpu idleness check, and add suspend inhibit mechanism

* Tue Apr 7 2009 Paul Fox <pgf@laptop.org>
- 3-1
- convert to HAL-based operation

* Thu Mar 19 2009 Paul Fox <pgf@laptop.org
- 2-3
- removed extra dcon calls.

* Thu Mar 19 2009 Paul Fox <pgf@laptop.org
- 2-2
- bug fixing

* Tue Mar 17 2009 Paul Fox <pgf@laptop.org
- 2-1 
- added powerd-config, and added blank-or-shutdown after sleep
  capability

* Fri Mar 13 2009 Paul Fox <pgf@laptop.org>
- 1-2
- fix rpmlint errors, move daemons to /usr/sbin

